## Набор ролей приложений Cartridge для проекта Уроборос

Cartridge-приложение для упаковки в rock. Содержит две роли:
- topology: роль для получения топологии кластера, vshard-групп и спейсов в них;
- replicator: роль для выполнения функций репликации.

### Роль uroboros.roles.uroboros-topology

Роль зависит от роли `cartridge.roles.vshard-router`. Поднимает два HTTP-эндпойнта: `/uroboros/api/v1/topology` и `/uroboros/api/v1/health`. Для обращения к ним используется метод GET.

Эндпойнт `/uroboros/api/v1/topology` возвращает в ответ топологию кластера в формате JSON со следующей структурой:

```
[
    {
        "name" = string,
        "bucket_count" = int,
        "replicasets" = [
            {
                "uuid" = string,
                "is_storage" = bool,
                "is_router" = bool,
                "servers" = {
                    {"uuid" = string, "uri" = string, "is_leader" = bool}
                    ...
                },
                "spaces" = [
                    {
                        "space_id" = int,
                        "space_name" = string,
                        "bucket_id_index" = int
                    },
                    ...
                ],
                "vshard_group" = string
            },
            ...
        ]
    }
    ...
]
```

Описания формата спейсов и первичного ключа содержат JSON, закодированные в строку.

Эндпойнт может принимать параметр `replicator_pass` (строка). В случае его передачи роль при опросе инстансов будет убеждаться в наличии специального пользователя для репликации. Если пользователь существует, то его пароль будет изменен. В противном случае пользователь будет создан. 

Эндпойнт `/uroboros/api/v1/health` предназначен для хелсчека роли.

### Роль uroboros.roles.uroboros-replicator

Роль зависит от роли `cartridge.roles.vshard-storage` и предназначена для выполнения операций репликации DML и DDL. Она должна быть развернута на всех инстансах, входящих в состав репликасетов с шардированными хранилищами.
Роль содержит функции для выполнения DML операций REPLACE и DELETE. Для их выполнения используется созданный в рамках работы проекта специальный пользователь для репликации.
