#!/usr/bin/env tarantool

require('strict').on()
package.setsearchroot()

local cartridge = require('cartridge')

assert(cartridge.cfg({
    workdir = 'tmp/db',
    cluster_cookie = 'test-cluster-cookie',
    bucket_count = 1000,
    roles = {
        'uroboros.roles.topology',
        'uroboros.roles.replicator',
        'roles.router',
        'roles.storage-1',
        'roles.storage-2',
    },
    upgrade_schema = true,
    vshard_groups = { "default", "test", "new" },
}))
